<template>
<div class="mn-file-name-container">
    <v-text-field
        v-if="isFile"
        flat
        solo
        dense
        hide-details
        background-color="transparent"
        :error="error" 
        :error-messages="errorMessage"
        v-model.trim="inputText"
        @input="handleInput($event)" 
    />
</div>
    
    
</template>

<script lang="ts">
import { defineComponent, ref, Ref, watch } from '@vue/composition-api'
import { useContents, useObservers } from '@/compositions';
import { renameFile } from '@/ipc';
import { concatPaths, buildDirContentObject } from '@/utils';

export default defineComponent({
    name: 'FileName',
    setup() {
        const fileName = useContents().getCurrentFileName;
        const initialValue = fileName.value;
        const inputText: Ref<string> = ref(initialValue);
        const error: Ref<boolean> = ref(false);
        const errorMessage: Ref<string> = ref('');
        const actionDelay = 300;
        const isFile: Ref<boolean> = ref(false);

        let inputTimeout: NodeJS.Timeout;

        /**
         * Updates the current selected file name.
         */
        const updateCurrentFile = (newName: string): Promise<void> => {
            return new Promise((resolve) => {
                const currentDir = useContents().getCurrentDir.value;
                const newCurrentFile = concatPaths([currentDir, newName], '/', '.md');

                useContents().setCurrentFile(newCurrentFile);

                resolve();
            });
        }

        const emitUpdatedFileEvent = (newName: string): Promise<void> => {
            return new Promise((resolve) => {
                const oldPathToFile = useContents().getCurrentFile.value;
                const currentDir = useContents().getCurrentDir.value;
                const newPathToFile = concatPaths([currentDir, newName], '/', '.md');

                const oldNode = buildDirContentObject(oldPathToFile);
                const newNode = buildDirContentObject(newPathToFile);

                useObservers().notifyObservers('fileNameUpdated', { oldNode, newNode  }).then(() => {
                    resolve();
                });
            });
        } 

        const performRenaming = async (newName: string) => {
            const currentFile = useContents().getCurrentFile.value;

            const response = await renameFile(newName, currentFile);

            if (response.success === false) {
                error.value = true;
                inputText.value = fileName.value;
                errorMessage.value = 'Another note with the same name already exists in the current location';
                return false;
            }
            
            error.value = false;
            errorMessage.value = '';

            return true;
        }

        const handleInput = async (newName: string) => {    
            clearTimeout(inputTimeout);

            inputTimeout = setTimeout(async () => {
                const renamingSuccessful = await performRenaming(newName);

                if (!renamingSuccessful) return;

                await emitUpdatedFileEvent(newName);

                await updateCurrentFile(newName);
            }, actionDelay);
        }

        watch(fileName, () => {
            inputText.value = fileName.value;
        });

        watch(useContents().isFile, (newValue) => {
          isFile.value = newValue;
        });

        return { inputText, handleInput, error, errorMessage, isFile }
    },
})
</script>

<style lang="scss">
  .mn-file-name-container {
      width: 100%;

      input {
        font-size: 1.4rem;
        font-weight: bold;
        padding: 0 !important;
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
      }
  }
</style>
